/* client.c
 * ANDHILL98 (soccer client for Robocup-98)
 * Tomohito Andou <tandou@ccm.cl.nec.co.jp>
 * Copyright (C) 1998 Tomohito Andou
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <sys/types.h>
#include <sys/time.h>
#include <unistd.h>
#include <signal.h>

#include "client.h"
#include "cl_nn.h"

#if 1
#define KEEPER
#endif

#define MAXMESG		(2000)
/*#define GO_ANGLE(odist)	(((odist) > 1.0)? 5 + 20/(odist): 25)*/
#define GO_ANGLE(odist)	(((odist) > 1.0)? 5 + 10/(odist): 15)
#define CHASE_RANGE	(30 + my_stamina/60)
#define KEEPER_RANGE	(20.0)
#define SEE_BALL_FREQ	(6 + ball_dist)
#define SEE_MY_FREQ	(100)
#define SAY_FREQ	(2)
#define SENSE_FREQ	(2)
#define REWARD_FREQ	(10)
#define POSI_FREQ	(8)
#define BALL_MATE_FREQ	(10)
#define POSI_ROUGH	(6)
/*#define BALL_ROUGH	(1.5)*/
#define BALL_ROUGH	(1.0)
#define VIEW_ROUGH	(0.80)
/*#define CHASE_BALL	(BALL_ROUGH*15)*/
#define CHASE_BALL	(BALL_ROUGH*6)
#define OBSTACLE_ANGLE	(25)
#define MY_KICKABLE	(0.95)
#define ENEMY_KICKABLE	(0.2)
/*#define BALL_CATCH	(0.70)*/
#define BALL_CATCH	(0.50)
#define CATCH_MARGIN	(3.0)
#define PASS_MARGIN	(5.0)
#define WALK_RATE	(0.30)

Socket		sock;
int		learn_flag;
int		output_flag;
int		test_flag;

long		game_time;
char		game_team[16];
Side		game_side;
int		game_unum;
int		game_mode;
int		game_my_score;
int		game_op_score;

long		sense_time;

long		my_time;
double		my_x;
double		my_y;
int		my_Sx;
int		my_Sy;
double		my_dir;
double		my_stamina;
double		my_effort;
double		my_view;	/* 45,90,180 */
double		my_gox;
double		my_goy;
int		my_unum;

long		my_vel_time;
double		my_vel_x;
double		my_vel_y;
double		my_vel;

long		ball_time;
double		ball_x;
double		ball_y;
double		ball_dir;
double		ball_dist;
double		ball_dir_chng;
double		ball_dist_chng;
double		ball_ex;
double		ball_ey;
int		ball_Sx;
int		ball_Sy;

long		ball_mate_time;
double		ball_mate;

long		ball_vel_time;
double		ball_vel_x;
double		ball_vel_y;
double		ball_vel;

long		map_time;
char		map_char[SMALL_X][SMALL_Y];
double		sc_base[SMALL_X][SMALL_Y][2];
int		offsideline;
int		offsideback;

int		info_flag;
int		see_flag;
int		turn_flag;
int		seebl_flag;
int		reached_posi;
int		reached_ball;
long		last_say;
long		last_sense;
long		last_reward;
long		last_posi;
static long	last_catch = -999;
static long	last_kick = -999;
int		posi_mode;
int		chase_flag;

SeenObj		nearest_player;
SeenObj 	seen_player[21];
int		seen_num;
SeenObj		nearest_enemy;
int		seen_enemy;

double off_posi[4][11][2] = {{
/* andou's position (normal) */
  {-51.5,	0.0},
  {-29.5,	-6.2},
  {-29.5,	6.2},
  {-16.4, 	-12.4},
  {-16.4,	12.4},
  {-9.8,	0.0},
  {3.3,		-12.4},
  {3.3,		12.4},
  {16.4,	0.0},
  {36.1,	-6.2},
  {36.1,	6.2}
},{
/* andou's position (wave) */
  {-51.5,	0.0},
  {-3.3,	6.2},
  {-3.3,	-6.2},
  {3.3,		18.5},
  {3.3,		-18.5},
  {9.8,		0.0},
  {16.4,	12.4},
  {16.4,	-12.4},
  {23.0,	0.0},
  {42.6,	6.2},
  {42.6,	-6.2}
},{
/* andou's position 2 */
  {-51.5,	0.0},
  {-29.5,	-6.2},
  {-29.5,	6.2},
  {-16.4, 	-18.5},
  {-16.4,	18.5},
  {-9.8,	0.0},
  {3.3,		-10.0},
  {3.3,		10.0},
  {16.4,	0.0},
  {36.1,	-6.2},
  {42.6,	6.2}
},{
/* muku's position */
  {-51.5,	0.0},
  {-36.1,	6.2},
  {-29.5, 	-6.2},
  {-23.0,	-18.5},
  {-16.4,	18.5},
  {-3.3,	6.2},
  {3.3,		-6.2},
  {16.4,	-18.5},
  {23.0,	18.5},
  {36.1,	12.4},
  {36.1,	-12.4}
}};
double init_posi[4][11][2] = {{
/* andou's position (normal) */
  {-51.5,	0.0},
  {-29.5,	-6.2},
  {-29.5,	6.2},
  {-16.4, 	-12.4},
  {-16.4,	12.4},
  {-9.8,	0.0},
  {-2.0,	-18.5},
  {-2.0,	18.5},
  {-1.0,	0.0},
  {-3.3,	-6.2},
  {-3.3,	6.2}
},{
/* andou's position (wave) */
  {-51.5,	0.0},
  {-9.8,	6.2},
  {-9.8,	-6.2},
  {-1.0,	18.5},
  {-1.0,	-18.5},
  {-1.0,	0.0},
  {-1.0,	2.0},
  {-1.0,	-2.0},
  {-1.0,	-4},
  {-1.0,	4},
  {-1.0,	-6}
},{
/* andou's position 2 */
  {-51.5,	0.0},
  {-29.5,	-6.2},
  {-29.5,	6.2},
  {-16.4, 	-18.5},
  {-16.4,	18.5},
  {-9.8,	0.0},
  {-1.0,	-6.2},
  {-1.0,	6.2},
  {-1.0,	0.3},
  {-1.0,	-18.5},
  {-1.0,	18.5}
},{
/* muku's position */
  {-51.5,	0.0},
  {-36.1,	6.2},
  {-29.5, 	-6.2},
  {-23.0,	-18.5},
  {-16.4,	18.5},
  {-3.3,	6.2},
  {-1.0,	-0.0},
  {-1.0,	-18.5},
  {-1.0,	18.5},
  {-1.0,	12.4},
  {-1.0,	-12.4}
}};

double maxi(double x, double y) { if (x>=y) return x; else return y; }
double mini(double x, double y) { if (x<=y) return x; else return y; }

/*
 * message $B$NAw<u?.(B
 */

void message_loop(void)
{
  fd_set		readfds;
  int			max_fd, n;
  static char		buf[MAXMESG], *tmp;
  SensorInfo		info;
  extern void		handler();
  struct timeval	zerotv;
  struct itimerval	itv, oitv;
  long			tmp_time;

  zerotv.tv_sec		= 0;
  zerotv.tv_usec	= 0;

  itv.it_interval.tv_sec	= 0;
  itv.it_interval.tv_usec	= 100000;
  itv.it_value.tv_sec		= 0;
  itv.it_value.tv_usec		= 100000;

  signal(SIGALRM, handler);
  setitimer(ITIMER_REAL, &itv, &oitv);

  while (1) {
    sigpause(sigblock(0L));

    signal(SIGALRM, SIG_IGN);

    FD_ZERO(&readfds);
    FD_SET(sock.socketfd, &readfds);

    max_fd = sock.socketfd + 1;
    if (select(max_fd, &readfds, 0, 0, &zerotv) == -1) {
      perror("select");
      break;
    }

    see_flag ++;
    if (FD_ISSET(sock.socketfd, &readfds))
      while ((n = receive_message(&sock, buf, MAXMESG)) == TRUE) {
#if 0
	fputs(buf, stdout);
#endif
	if (scan_info(buf, &info, game_team)) {
	  if (info.type == SIT_Hear)
	    hear(info.info.hear);
	  else if (info.type == SIT_See)
	    see(info.info.see);
	} else {
	  /*(sense_body 292 (view_mode high normal) (stamina 1715.88 0.86) (speed 0) (kick 10) (dash 89) (turn 75) (say 83))*/
	  if (sscanf(buf, "(sense_body %ld ", &(tmp_time)) &&
	      tmp_time > sense_time) {
	    sense_time = tmp_time;
	    tmp = buf;
	    tmp = next_token(tmp + 1);
	    tmp = next_token(tmp);
	    tmp = next_token(tmp);
	    sscanf(tmp, "(stamina %lf %lf) (speed %lf)",
		   &(my_stamina), &(my_effort), &(my_vel));
	    my_vel_x = my_vel * cos(Deg2Rad(my_dir));
	    my_vel_y = my_vel * sin(Deg2Rad(my_dir));
	  }
	}
      }
#if 0
    if (game_unum==11)
      show();
#endif

    action();
    /*if (see_flag >= 2) printf("see_flag: %d\n", see_flag);*/

#if 0
    getitimer(ITIMER_REAL, &oitv);
    printf("rest time = %ld / 100000\n", oitv.it_value.tv_usec);
#endif

    signal(SIGALRM, handler);
  }
}

/*
 * $B%?!<%sKh$K>pJs$r99?7(B
 */

void handler(int sig)
{
  double	tx, ty;
  int		i;

  /*
   * Users of 4.2 and 4.3BSD systems should un-comment
   * this line, which will make this program
   * behave as if it were on a non-Berkeley system.
   */
  /* signal(sig, SIG_DFL); */

  if (!(game_mode & 8))  game_time ++;

#if 0
  printf("\n****** %s %d %ld ",
	 game_team, game_unum, game_time);
#endif

  my_x		+= my_vel_x;
  my_y		+= my_vel_y;
  my_Sx		= L2Sx(my_x);
  my_Sy		= L2Sy(my_y);
  my_stamina	+= STAMINA_INC; /* ???? */
  my_stamina	= restrict(my_stamina, 0, STAMINA_MAX);

  ball_x	+= ball_vel_x;
  ball_y	+= ball_vel_y;
  ball_dir      = Rad2Deg(atan2(ball_y - my_y, ball_x - my_x)) - my_dir;
  ball_dir      = regDeg(ball_dir);
  ball_dist     = sqrt(Pow(ball_x - my_x) + Pow(ball_y - my_y));

  for (i=0; i<seen_num; i++) {
    tx = seen_player[i].dist * cos(Deg2Rad(seen_player[i].dir)) - my_vel;
    ty = seen_player[i].dist * sin(Deg2Rad(seen_player[i].dir));
    seen_player[i].dir = Rad2Deg(atan2(ty, tx));
    seen_player[i].dist = sqrt(Pow(tx) + Pow(ty));
  }

  my_vel_x	*= PL_DECAY;
  my_vel_y	*= PL_DECAY;
  my_vel	*= PL_DECAY;

  ball_vel_x	*= BALL_DECAY;
  ball_vel_y	*= BALL_DECAY;
  ball_vel	*= BALL_DECAY;

#if 0
  printf("******\n");
#endif
}

/*
 * $B%\!<%kJa3M0LCV$N?dDj(B
 */

void ball_estimate(void)
{
  if (ball_vel > BALL_CATCH &&
      Abs(ball_x) < PITCH_LENGTH/2.0 - CATCH_MARGIN &&
      Abs(ball_y) < PITCH_WIDTH/2.0 - CATCH_MARGIN) {
    ball_ex = (ball_vel_x - BALL_CATCH * ball_vel_x/ball_vel) * BALL_ONESTEP;
    ball_ey = (ball_vel_y - BALL_CATCH * ball_vel_y/ball_vel) * BALL_ONESTEP;
    if (Abs(ball_ex) > 0.001) {
      if (ball_x + ball_ex > PITCH_LENGTH/2.0 - CATCH_MARGIN) {
	ball_ey *= (PITCH_LENGTH/2.0 - CATCH_MARGIN - ball_x) / ball_ex;
	ball_ex = PITCH_LENGTH/2.0 - CATCH_MARGIN - ball_x;
      } else if (ball_x + ball_ex < -PITCH_LENGTH/2.0 + CATCH_MARGIN) {
	ball_ey *= (-PITCH_LENGTH/2.0 + CATCH_MARGIN - ball_x) / ball_ex;
	ball_ex = -PITCH_LENGTH/2.0 + CATCH_MARGIN - ball_x;
      }
    }
    if (Abs(ball_ey) > 0.001) {
      if (ball_y + ball_ey > PITCH_WIDTH/2.0 - CATCH_MARGIN) {
	ball_ex *= (PITCH_WIDTH/2.0 - CATCH_MARGIN - ball_y) / ball_ey;
	ball_ey = PITCH_WIDTH/2.0 - CATCH_MARGIN - ball_y;
      } else if (ball_y + ball_ey < -PITCH_WIDTH/2.0 + CATCH_MARGIN) {
	ball_ex *= (-PITCH_WIDTH/2.0 + CATCH_MARGIN - ball_y) / ball_ey;
	ball_ey = -PITCH_WIDTH/2.0 + CATCH_MARGIN - ball_y;
      }
    }
    ball_ex += ball_x;
    ball_ey += ball_y;
  } else {
    ball_ex = ball_x;
    ball_ey = ball_y;
  }
  ball_Sx = L2Sx(ball_ex);
  ball_Sy = L2Sy(ball_ey);
}

/*
 * $B8D?M$N9TF0$O$3$3$K5-=R(B
 */

void action(void)
{
  static char		msg_buf[MAXMESG];
  double		go_dir, go_dist;
  int			px, py, ninzu;

  /* $B%;%s%5>pJs$,ITB-$7$F$$$J$$$+(B */
  if ((info_flag & 1) == 0) {
    send_message(sock, "(sense_body)");
    last_sense = game_time;
    /*printf("???\n");*/
    return;
  } else if ((info_flag & 6) != 6) {
    turn(my_view * VIEW_ROUGH * turn_flag);
    info_flag &= ~1;
    return;
  } else if (game_time - ball_time > SEE_BALL_FREQ) {
    turn_flag = (ball_dir >= 0)? 1: -1;
    /*turn(ball_dir);*/
    send_message(sock, "(sense_body)");
    last_sense = game_time;
    info_flag &= ~3;
    return;
  } else if (game_time - my_time > SEE_MY_FREQ) {
    turn(180.0);
    info_flag &= ~5;
    return;
  }

  /* say$B$9$k$+$I$&$+(B */
  if (game_time - last_say > SAY_FREQ && random()%2 == 0)
    say();
  else if (game_time - last_sense > SENSE_FREQ && random()%2 == 0) {
    send_message(sock, "(sense_body)");
    last_sense = game_time;
  }

  /* $B%-%C%/%*%UA0$OFCJL$J=hM}(B */
  if (game_mode & 8) {
    if (random()%11 == 0) init_position();
    if (Pow(my_x-my_gox) + Pow(my_y-my_goy) > Pow(POSI_ROUGH)
	|| my_x <= -PITCH_LENGTH/2.0 || my_x >= 0
	|| my_y <= -PITCH_WIDTH/2.0 || my_y >= PITCH_WIDTH/2.0) {
      reached_posi = 0;
      move(my_gox, my_goy);
    } else {
      reached_posi = 1;
      turn(ball_dir);
    }
    return;
  }

  /* $B%\!<%k$N$$$A(B */
  ball_estimate();

  /* $B%*%U%5%$%I%i%$%s(B */
  ninzu = 0;
  offsideline = (ball_x > 0) ? L2Sx(ball_x) : (SMALL_X/2);
  for (px=SMALL_X-1; px>offsideline; px--) {
    for (py=0; py<SMALL_Y; py++) {
      if ((map_char[px][py]&2) || (map_char[px][py]&7) == 4)
	ninzu ++;
    }
    if (ninzu > 1) {
      offsideline = px;
      break;
    }
  }
  /* $B%*%U%5%$%I%P%C%/(B */
  ninzu = 0;
  offsideback = SMALL_X/2;
  for (px=0; px<offsideback; px++) {
    for (py=0; py<SMALL_Y; py++) {
      if (map_char[px][py]&1)
	ninzu ++;
    }
    if (ninzu > 1) {
      offsideback = px;
      break;
    }
  }

  /* $B3X=,$9$k>l9g$O>o$K%M%C%H%o!<%/$rDL$9$3$H(B */
  if (learn_flag & 1)
    position();

#if 0
  /* $B%\!<%k$,Ja$l$k;~(B(keeper) */
  if (game_unum == 1
      && !(game_mode & 1)
      /*&& ball_vel_x <= 0.0*/
      && last_catch < game_time - CATCH_CYCLE
      && my_x < -PITCH_LENGTH/2.0 + PENALTY_AREA_LENGTH
      && my_x >= -PITCH_LENGTH/2.0
      && fabs(my_y) < PENALTY_AREA_WIDTH/2.0
      && ball_dir > -70
      && ball_dir < 70
      && fabs(ball_dist * sin(Deg2Rad(ball_dir))) < CATCH_W/2.0*0.8
      && ball_dist * cos(Deg2Rad(ball_dir)) < CATCH_L*0.8) {
    sprintf(msg_buf, "(catch %.2f)\n", ball_dir);
    send_message(sock, msg_buf);
    last_catch = game_time;
    printf("Ball catch dir: %g dist: %g %s", ball_dir, ball_dist, msg_buf);
  }
#endif

  /* $B%\!<%k$,=3$l$k;~(B */
  /*  if (ball_dist < MY_KICKABLE + PL_SIZE + BALL_SIZE) {*/
  if (!(game_mode&4) &&
      (ball_dist < PL_SIZE + BALL_SIZE +
       MY_KICKABLE * ((last_kick<=game_time-10 || ball_x<my_x) ? 1.0 : 0.5))) {
    pass();

#if 1
    /* $B%-%C%/$K$h$kJs=7(B */
    if ((game_time - last_reward > REWARD_FREQ) && (game_mode == 0)) {
      /* $B%\!<%k$N$=$P$KL#J}$,$$$J$$$H$-(B */
      posi_getattr(ball_Sx,ball_Sy);
      if (po_i[2] >= 0.0) {

	if (output_flag & 0x80) {
	  printf("%s %2d %ld\tkick:\n",
		 game_team, my_unum, game_time);
	  fflush(stdout);
	}
	/* check 1 */
	if (learn_flag & 1)
	  reward(1.0);
	last_reward = game_time;
      }
    }
#endif

  } else {
    /* $B%\!<%k$rDI$&(B */
    if (chase()) {
      if (ball_dist <= CHASE_BALL || ball_vel <= BALL_CATCH) {
	go(ball_dir, ball_dist-PL_SIZE-BALL_SIZE);
	/* go(ball_dir+ball_dir_chng*ball_dist,
	   ball_dist-PL_SIZE-BALL_SIZE+ball_dist_chng*ball_dist); */
      } else if ((reached_ball == 0 &&
		  Pow(my_x-ball_ex) + Pow(my_y-ball_ey) > Pow(BALL_ROUGH)) ||
		 (reached_ball == 1 &&
		  Pow(my_x-ball_ex) + Pow(my_y-ball_ey) > Pow(POSI_ROUGH))) {
	reached_ball = 0;
	if (game_mode & 1)
	  go_abs(ball_ex, ball_ey - 5.0*(ball_ey-my_y)/fabs(ball_ey-my_y));
	else
	  go_abs(ball_ex, ball_ey);
      } else {
	reached_ball = 1;
	turn(ball_dir);
      }
    }

    /* $B%\!<%k$,1s$$;~(B */
    else {
      reached_ball = 0;
      position();
      if ((reached_posi == 0 &&
	   Pow(my_x-my_gox) + Pow(my_y-my_goy) > Pow(POSI_ROUGH/2)) ||
	  (reached_posi == 1 &&
	   Pow(my_x-my_gox) + Pow(my_y-my_goy) > Pow(POSI_ROUGH)))
	reached_posi = 0;
      else
	reached_posi = 1;
      if (reached_posi == 0 && !(game_mode & 16)) {
	if ((game_mode & 2) && ball_dist <= 10.0) {
	  go_dir = Rad2Deg(atan2(my_goy - my_y, my_gox - my_x)) - my_dir;
	  go_dir = regDeg(go_dir);
	  go_dist = sqrt(Pow(my_goy - my_y) + Pow(my_gox - my_x));
	  if (regDeg(go_dir - ball_dir) >= 0) go_dir = regDeg(ball_dir + 90);
	  else go_dir = regDeg(ball_dir - 90);
	  go(go_dir, go_dist * fabs(sin(Deg2Rad(go_dir - ball_dir))));
	} else
	  go_abs(my_gox, my_goy);
      } else {
	turn(ball_dir);
      }
    }
  }
}

/*
 * $B%]%8%7%g%K%s%0$H$=$N3X=,(B
 */

void position(void)
{
  int		ox, oy, px, py;
  double	oval, max, min, now;
  static long	counter = 0;

#ifdef KEEPER
  if (my_unum == 1) {
    my_gox = -51.5;
    my_goy = 0.0;
    return;
  }
#endif
  if (!test_flag) {
    if (game_time - last_posi <= POSI_FREQ
	|| ((game_time%11) != my_unum-1
	    && ((game_time-1)%11) != my_unum-1))
      return;
    last_posi = game_time;
  }
  if ((learn_flag & 3) == 2) {
    if (output_flag & 0x4) {
      posi_getattr(my_Sx,my_Sy);
      printf("%s %2d %ld\ta_attr: %.2g %.2g %.2g %.2g %.2g\n",
	     game_team, my_unum, game_time,
	     po_i[0], po_i[1], po_i[2], po_i[3], po_i[4]);
      fflush(stdout);
    }
    if (my_stamina > STAMINA_THR) {
      my_gox = off_posi[posi_mode][my_unum-1][0];
      my_goy = off_posi[posi_mode][my_unum-1][1];
    } else {
      my_gox = my_x;
      my_goy = my_y;
    }
    if (my_gox > S2Lx(offsideline-1)) my_gox = S2Lx(offsideline-1);
    /* test */
/*    if (my_gox < ball_x && my_gox < 0.0) my_gox = mini(ball_x, 0.0);*/
    return;
  }

  if (learn_flag & 1) posi_begin();
  posi_getattr(my_Sx,my_Sy);
  posi_exec();
  ox = my_Sx;
  oy = my_Sy;
  oval = max = min = now = po_o[0];
  po_i[4] = get_safety(ball_Sx, ball_Sy) / 20.0;
  if ((output_flag & 0x20) && (counter%100) == 0) {
    show();
    printf("position\n");
  }
  for (py=0; py<SMALL_Y; py++) {
    for (px=0; px<SMALL_X; px++) {
      posi_getattr(px,py);
      posi_exec();
      if (learn_flag & 1) {
	posi_backprop(0.1-po_o[0], 0);
	posi_backprop(0.9-po_o[0], 1);
      }
      /* No Exploration */
      if (my_stamina - sqrt(Pow(px-my_Sx)+Pow(py-my_Sy))*394 > STAMINA_THR &&
	  po_o[0] > oval) {
	ox = px;
	oy = py;
	oval = po_o[0];
      }
      if (po_o[0] > max) max = po_o[0];
      if (po_o[0] < min) min = po_o[0];
      if ((output_flag & 0x20) && (counter%100) == 0)
	printf("%.2f ", po_o[0]);
    }
    if ((output_flag & 0x20) && (counter%100) == 0) {
      printf("\n");
      fflush(stdout);
    }
  }
  if (oval <= now ||
      now >= min+(max-min)*((my_stamina+2000.0)/4000.0)) {
    ox = my_Sx;
    oy = my_Sy;
    oval = now;
  }
  counter++;

  if (test_flag && (random() % 1) == 0) {
    ox = random() % SMALL_X;
    oy = random() % SMALL_Y;
  }

  if (learn_flag & 1) {
#if 1
    /* $B%\!<%k$N0LCV$r6/2=(B(observational reinforcement) */
    if ((!test_flag) &&
	/*(game_mode == 0 || (game_mode & 1)) &&*/
	(game_mode == 0) &&
	(ball_Sx <= offsideline-1 && ball_Sx >= offsideback)) {
      /* $B%\!<%k$N$=$P$KL#J}$,$$$J$$$H$-(B */
      posi_getattr(ball_Sx,ball_Sy);
      if (po_i[2] >= 0.0) {
	/* check 2 */
	posi_exec();
/*	posi_backprop_sp((0.9-po_o[0])*SMALL_X*SMALL_Y, 0.070, 0);*/
/*	posi_backprop_sp((0.9-po_o[0])*SMALL_X*SMALL_Y, 0.035, 0);*/
/*	posi_backprop_sp((0.9-po_o[0])*SMALL_X*SMALL_Y, 0.10, 0);*/
	posi_backprop_sp((0.9-po_o[0])*SMALL_X*SMALL_Y, 0.30, 0);
	if (output_flag & 0x8) {
	  printf("%s %2d %ld\tb_attr: %.2g %.2g %.2g %.2g %.2g\n",
		 game_team, my_unum, game_time,
		 po_i[0], po_i[1], po_i[2], po_i[3], po_i[4]);
	  fflush(stdout);
	}
      }
    }
#endif

    /* reinforcement */
    posi_getattr(my_Sx,my_Sy);
    posi_exec();
    posi_backprop((0.9-po_o[0])*SMALL_X*SMALL_Y, 0);
    posi_backprop((0.1-po_o[0])*SMALL_X*SMALL_Y, 1);
    posi_end();
#if 0
    /* check 3 */
    /* $B0BA4EY$K$h$kJs=7(B */
    reward(po_i[4] * 0.1);
#endif
  }

  if (output_flag & 0x4) {
    if (!(learn_flag & 1)) posi_getattr(my_Sx,my_Sy);
    printf("%s %2d %ld\ta_attr: %.2g %.2g %.2g %.2g %.2g\n",
	   game_team, my_unum, game_time,
	   po_i[0], po_i[1], po_i[2], po_i[3], po_i[4]);
    fflush(stdout);
  }

  if (learn_flag & 2) {
    my_gox = off_posi[posi_mode][my_unum-1][0];
    my_goy = off_posi[posi_mode][my_unum-1][1];
  } else {
    my_gox = S2Lx(ox);
    my_goy = S2Ly(oy);
  }
  if (my_gox > S2Lx(offsideline-1)) my_gox = S2Lx(offsideline-1);
  /* test */
/*  if ((learn_flag & 2) && my_unum <= 8) my_gox += mini(ball_x, 0.0) + 25.0;*/
/*  if (my_gox < ball_x && my_gox < 0.0) my_gox = mini(ball_x, 0.0);*/
}

void posi_getattr(int px, int py)
{
  int qx, qy;

  po_i[0] = sc_base[px][py][0] / SMALL_X - 0.5;
  po_i[1] = sc_base[px][py][1] / SMALL_X - 0.5;
/*  po_i[5] = sqrt(Pow(px-my_Sx) + Pow(py-my_Sy)) / 4.0 - 0.5;
  if (po_i[5] > 0.5) po_i[5] = 0.5;*/
  po_i[2] = 16;
  po_i[3] = 16;
  for (qy=0; qy<SMALL_Y; qy++)
    for (qx=0; qx<SMALL_X; qx++) {
      if ((map_char[qx][qy] & 5) == 5 &&
	  po_i[2] > Pow(qx-px) + Pow(qy-py))
	po_i[2] = Pow(qx-px) + Pow(qy-py);
      else if ((map_char[qx][qy] & 6) == 6 &&
	       po_i[3] > Pow(qx-px) + Pow(qy-py))
	po_i[3] = Pow(qx-px) + Pow(qy-py);
    }
  po_i[2] = sqrt(po_i[2]) / 4.0 - 0.5;
  po_i[3] = sqrt(po_i[3]) / 4.0 - 0.5;
}

/*
 * $B=i4|0LCV$r5a$a$k(B
 */

void init_position(void)
{
  int           ox, oy, px, py;
  double        oval;

#ifdef KEEPER
  if (my_unum == 1) {
    my_gox = -51.5;
    my_goy = 0.0;
    return;
  }
#endif
  if (learn_flag & 2) {
    my_gox = init_posi[posi_mode][my_unum-1][0];
    my_goy = init_posi[posi_mode][my_unum-1][1];
    return;
  }

  ox = my_Sx;
  oy = my_Sy;
  oval = -100;
  po_i[4] = get_safety(ball_Sx, ball_Sy) / 20.0;
  for (py=0; py<SMALL_Y; py++)
    for (px=0; px<SMALL_X/2; px++) {
      posi_getattr(px,py);
      posi_exec();
      if ((po_o[0] > oval
	   && (my_Sx >= SMALL_X/2
	       || sqrt(Pow(px-my_Sx) + Pow(py-my_Sy)) <= 2))
	  || (po_o[0] == oval
	      && (px == SMALL_X/2-1 && py == SMALL_Y/2))) {
	ox = px;
	oy = py;
	oval = po_o[0];
      }
    }
  my_gox = S2Lx(ox);
  my_goy = S2Ly(oy);
}

/*
 * $B%\!<%k$rDI$&$+$I$&$+$NH=CG(B
 */

int chase(void)
{
  double ll, mm;
  int i;

  chase_flag = 0;
  if (game_mode & 2) return 0;

  /* if (ball_dist <= CHASE_BALL) return 1; */

#if 0
  /* $B1s$$$H$-$ODI$o$J$$(B */
  if (sqrt(Pow(ball_ex-my_x) + Pow(ball_ey-my_y)) > CHASE_RANGE
      && !((game_mode & 1) && ball_dist <= CHASE_RANGE*2))
    return 0;
#endif

#ifdef KEEPER
  /* $B%-!<%Q!<$OFCJL(B */
  if (my_unum == 1) {
    if (ball_ex > - PITCH_LENGTH/2.0 + KEEPER_RANGE
	|| Abs(ball_ey) > KEEPER_RANGE)
      return 0;

    if (ball_dist <= 10.0) { chase_flag = 1; return 1; }
  }
#endif

#if 1
  /* $B%\!<%k$N6a$/$KL#J}$,$$$k;~$ODI$o$J$$(B(see) */
  for (i=0; i<seen_num; i++) {
    if (seen_player[i].id.player.team == WT_Our) {
      mm = (seen_player[i].dist
	    * cos(Deg2Rad(seen_player[i].dir + my_dir)) + my_x
	    - ball_ex);
      ll = Pow(mm);
      mm = (seen_player[i].dist
	    * sin(Deg2Rad(seen_player[i].dir + my_dir)) + my_y
	    - ball_ey);
      ll += Pow(mm);
      ll = sqrt(ll);
      mm = sqrt(Pow(my_x - ball_ex) + Pow(my_y - ball_ey));
      /*if (ll < mm*0.6 || ll < mm-5.0)*/
      /*if (ll < mm*0.9 || ll < mm-2.0)*/
      if (ll < mm*0.7 || ll < mm-3.0)
	return 0;
    }
  }
#endif

  /* $B%\!<%k$N6a$/$KL#J}$,$$$k;~$ODI$o$J$$(B(hear) */
  if (ball_mate_time >= game_time - BALL_MATE_FREQ
      && ball_mate <
	(ball_dist - (my_stamina-STAMINA_THR) * PL_ONESTEP * DASH_RATE))
    return 0;

  chase_flag = 1;
  return 1;
}

/*
 * $B$"$kCOE@$K0\F0(B
 */

void go_abs(double ox, double oy)
{
  double odir, odist;

  odir = Rad2Deg(atan2(oy - my_y, ox - my_x)) - my_dir;
  odir = regDeg(odir);
  odist = sqrt(Pow(ox - my_x) + Pow(oy - my_y));
  go(odir, odist);
}

/*
 * $B$"$kJ}8~$K0\F0(B
 */

void go(double odir, double odist)
{
  double	pdir, ddir;

  /* $B:G$b6a$$%W%l%$%d$rHr$1$k(B */
  if (seen_num > 0 && nearest_player.dist < odist) {
    if (PL_SIZE * 2 > nearest_player.dist)
      nearest_player.dist = PL_SIZE * 2;
    pdir = Rad2Deg(asin(PL_SIZE * 2 / nearest_player.dist));
    ddir = regDeg(odir - nearest_player.dir);
    if (ddir <= 0 && ddir > - pdir - GO_ANGLE(odist))
      odir = regDeg(nearest_player.dir - pdir - GO_ANGLE(odist));
    else if (ddir >= 0 && ddir < pdir + GO_ANGLE(odist))
      odir = regDeg(nearest_player.dir + pdir + GO_ANGLE(odist));
    /*
    if (ddir <= 0 && ddir > - pdir)
      odir = regDeg(nearest_player.dir - pdir - GO_ANGLE(odist));
    else if (ddir >= 0 && ddir < pdir)
      odir = regDeg(nearest_player.dir + pdir + GO_ANGLE(odist));
    */
  }

  if (Abs(odir) > GO_ANGLE(odist) ||
      my_vel > PL_SP_MAX*0.8)
    turn(odir);
  else
    dash(mini((odist-my_vel)/DASH_RATE / PL_ONESTEP * 1.0,
	      (PL_SP_MAX-my_vel)/DASH_RATE));
}

/* 
 * $B%\!<%k$r$I$3$K=3$k$+H=CG$9$k(B
 */

void pass(void)
{
  int		tmp_char;
  int		ox, oy, px, py, count;
  double	max;

#if 0
  /* offside? */
  if (ball_vel_x > 0.0 && ball_x > 0.0 && last_kick < game_time - 20) {
    count = 0;
    for (px=my_Sx+1; px<SMALL_Y; px++)
      for (py=0; py<SMALL_Y; py++)
	if ((map_char[px][py] & 6) == 6)
	  if (++count > 1) break;
    if (count <= 1)
      return;
  }
#endif

  /* $B%4!<%k$KFO$/;~(B */
  if ((Pow(ball_ex-PITCH_LENGTH/2.0)+Pow(ball_ey) < Pow(BALL_DISTANCE)*0.95) ||
       (Pow(ball_x-PITCH_LENGTH/2.0)+Pow(ball_y) < Pow(BALL_DISTANCE)*0.95)) {
    kick(PITCH_LENGTH/2.0, 0.0);
    return;
  }

  /* $B%9%b!<%k%F!<%V%k$+$i$NF0E*I>2A(B */
  tmp_char = map_char[my_Sx][my_Sy];
  map_char[my_Sx][my_Sy] |= 5;
  if (output_flag & 0x40) show();

  max = -100;
  ox = SMALL_X;
  oy = SMALL_Y/2;
  for (py=0; py<SMALL_Y; py++) {
    for (px=0; px<SMALL_X; px++) {
      get_safety(px, py);
      if (sqrt(Pow(px-ball_Sx) + Pow(py-ball_Sy)) >
	  /*BALL_DISTANCE * SMALL_X * 2.0 / PITCH_LENGTH)*/
	  BALL_DISTANCE * SMALL_X * 0.95 / PITCH_LENGTH)
	sa_o[0] -= 10;
      if (sa_o[0] > max) {
	ox = px;
	oy = py;
	max = sa_o[0];
      }
      if (output_flag & 0x40) printf("%4d", (int) (sa_o[0] * 10));
    }
    if (output_flag & 0x40) {
      printf("\n");
      fflush(stdout);
    }
  }

  map_char[my_Sx][my_Sy] = tmp_char;

  if (ox == my_Sx && oy == my_Sy) {
    /* $B%\!<%k$r%-!<%W(B */
    turn(my_view * VIEW_ROUGH);
    info_flag &= ~1;
    printf("test: keep\n");
  }
  else
    /* $B%Q%9(B */
    kick(S2Lx(ox), S2Ly(oy));
}

double get_safety(int px, int py) {
  int		qx, qy;

  sa_i[0] = sc_base[px][py][0];
  sa_i[1] = sc_base[px][py][1];
  sa_i[2] = 16;
  sa_i[3] = 16;
  for (qy=0; qy<SMALL_Y; qy++)
    for (qx=0; qx<SMALL_X; qx++) {
      if ((map_char[qx][qy] & 5) == 5 &&
	  sa_i[2] > Pow(qx-px) + Pow(qy-py))
	sa_i[2] = Pow(qx-px) + Pow(qy-py);
      else if ((map_char[qx][qy] & 6) == 6 &&
	       sa_i[3] > Pow(qx-px) + Pow(qy-py))
	sa_i[3] = Pow(qx-px) + Pow(qy-py);
    }
  sa_i[2] = sqrt(sa_i[2]);
  sa_i[3] = sqrt(sa_i[3]);
  return safety_exec();
}

/*
 * $B@)Ls$r2r>C$7$F=3$k(B($B4pAC(B)
 */

void kick(double kick_x, double kick_y)
{
  double	kick_dir, kick_dist, kick_pow, kick_scope;
  int		kick_flag, uncertain, dribble_flag, shoot_flag, i, j;
  double	xx, yy, ll, mm;
  double	tmp_dir;
  static int	chk_stack = 0;
  double	ball_vel_dir;

  kick_flag	= 0;
  dribble_flag	= 0;
  shoot_flag	= 0;
  uncertain	= 0;

  /* $B%7%e!<%H$+$I$&$+(B */
  if (kick_x >= PITCH_LENGTH/2.0 && Abs(kick_y) < GOAL_WIDTH/2.0) {
    kick_dist = sqrt(Pow(kick_y - ball_y) + Pow(kick_x - ball_x));
    if (kick_dist < 1.0) kick_dist = 1.0;
    kick_x += (kick_x - ball_x) * 100 / kick_dist;
    kick_y += (kick_y - ball_y) * 100 / kick_dist;
    shoot_flag = 1;
  }

  /* $B2>$NJ}8~!"5wN%$r7W;;(B */
  kick_dir = Rad2Deg(atan2(kick_y - ball_y, kick_x - ball_x)) - my_dir;
  kick_dir = regDeg(kick_dir);
  kick_dist = sqrt(Pow(kick_y - ball_y) + Pow(kick_x - ball_x));

#if 0
    /* $B2DG=$J$i?6$j8~$/(B */
    if (ball_dist_chng <= 0.1 &&
	/*ball_dist <= (MY_KICKABLE + PL_SIZE)*0.8 &&*/
	see_flag >= 1 &&
	ball_vel <= BALL_CATCH &&
	(seen_enemy == 0 || nearest_enemy.dist > 5.0 || (game_mode & 1)) &&
	Abs(kick_dir) > my_view*VIEW_ROUGH/2.0) {
      /*turn(my_view * VIEW_ROUGH * kick_flag);*/
      turn(kick_dir);
      /*
	 ball_vel_dir = Rad2Deg(atan2(ball_vel_y, ball_vel_x)) - my_dir;
	 ball_vel_dir = regDeg(ball_vel_dir);
	 turn(ball_vel_dir);
	 */
      printf("Furikaeri\n");
      return;
    }
#endif

  /* $B8e$m$K=3$k(B */
  if (PL_SIZE+BALL_SIZE+0.05 > ball_dist)
    ball_dist = PL_SIZE+BALL_SIZE+0.05;
  kick_scope = 180 - Rad2Deg(asin((PL_SIZE+BALL_SIZE+0.05) / ball_dist));

  if (Abs(regDeg(kick_dir - ball_dir)) > kick_scope) {
    /* $B:G$b6a$$E($N$$$J$$J}8~$K2s$k(B */
    if (seen_enemy > 0 &&
	nearest_enemy.dist <= 5.0) {
      if (regDeg(nearest_enemy.dir - ball_dir) >= 0)
	kick_flag = 1;
      else
	kick_flag = -1;
    } else if (my_y > PITCH_WIDTH*0.5-2.0)
      kick_flag = -1;
    else if (my_y < -(PITCH_WIDTH*0.5-2.0))
      kick_flag = 1;
    if (kick_flag == 0) {
      if (regDeg(kick_dir - ball_dir) >= 0)
	kick_flag = 1;
      else
	kick_flag = -1;
    }

    kick_dir = ball_dir - kick_scope * kick_flag;
    kick_dir = regDeg(kick_dir);
    /*kick_dist = 2 * ball_dist*cos(Deg2Rad(180 - kick_scope));*/
    /*kick_dist = 4.5;*/
    kick_dist = 5.0;
    dribble_flag = 1;
    shoot_flag = 0;
  }

  /* $BE($N$$$J$$J}8~$K=$@5$9$k(B */
  for (i=0, j=0; i<seen_num; i++, j++)
    if (seen_player[i].dist < kick_dist) {

      ll = sqrt(Pow(seen_player[i].dist) + Pow(ball_dist)
		- 2 * seen_player[i].dist * ball_dist
		* cos(Deg2Rad(seen_player[i].dir - ball_dir)));
      if (ll < PL_SIZE + BALL_SIZE + ENEMY_KICKABLE) {
	ll = PL_SIZE + BALL_SIZE + ENEMY_KICKABLE;
	uncertain = 1;
      }
      if (ll < (mm = sin(Deg2Rad(seen_player[i].dir - ball_dir))
		* seen_player[i].dist))
	ll = mm;
/*      yy = Rad2Deg(asin((PL_SIZE + BALL_SIZE + ENEMY_KICKABLE) / ll));*/
      yy = Rad2Deg(asin((PL_SIZE + ENEMY_KICKABLE) / ll));
      xx = Rad2Deg(asin(mm / ll));
      if (seen_player[i].dist > 5.0) yy += OBSTACLE_ANGLE;

      if (Abs(regDeg(ball_dir + xx - kick_dir)) < yy) {
	if (kick_flag == 0) {
	  if (regDeg(ball_dir + xx - kick_dir) >= 0)
	    kick_flag = -1;
	  else
	    kick_flag = 1;
	}
	kick_dir = ball_dir + xx + (yy) * kick_flag;
	kick_dir = regDeg(kick_dir);
	i = 0;
	if (j > 30) break;
      }
    }
  if (shoot_flag) {
    tmp_dir = Rad2Deg(atan2(GOAL_WIDTH/2.0 - ball_y,
			    PITCH_LENGTH/2.0 - ball_x)) - my_dir;
    tmp_dir = regDeg(tmp_dir);
    if (regDeg(kick_dir - (tmp_dir - 5)) > 0) kick_dir = regDeg(tmp_dir - 5);
    tmp_dir = Rad2Deg(atan2(- GOAL_WIDTH/2.0 - ball_y,
			    PITCH_LENGTH/2.0 - ball_x)) - my_dir;
    tmp_dir = regDeg(tmp_dir);
    if (regDeg(kick_dir - (tmp_dir + 5)) < 0) kick_dir = regDeg(tmp_dir + 5);
    /* printf("shoot!\n");*/
  }

  /* $B=3$kJ}8~!"5wN%$r5a$a$k(B */
  kick_x = ball_x + kick_dist * cos(Deg2Rad(my_dir + kick_dir));
  kick_y = ball_y + kick_dist * sin(Deg2Rad(my_dir + kick_dir));
  if (dribble_flag == 0 && shoot_flag == 0) {
    kick_x = restrict(kick_x, -PITCH_LENGTH/2.0 + PASS_MARGIN,
		      PITCH_LENGTH/2.0 - PASS_MARGIN);
    kick_y = restrict(kick_y, -PITCH_WIDTH/2.0 + PASS_MARGIN,
		      PITCH_WIDTH/2.0 - PASS_MARGIN);
  }

  kick_dir = Rad2Deg(atan2(kick_y - ball_y - ball_vel_y*BALL_ONESTEP,
			   kick_x - ball_x - ball_vel_x*BALL_ONESTEP))
    - my_dir;
  kick_dir = regDeg(kick_dir);
  kick_dist = sqrt(Pow(kick_y - ball_y - ball_vel_y*BALL_ONESTEP) +
		   Pow(kick_x - ball_x - ball_vel_x*BALL_ONESTEP));

  /* $B=3$kNO$r5a$a$k(B */
  kick_pow = kick_dist * 100.0 / (KICK_RATE*POWER_MAX / (1.0-BALL_DECAY));
  /* if (dribble_flag == 0) kick_pow *= 1.5;*/
  kick_pow = restrict(kick_pow, POWER_MIN, POWER_MAX);

  /* $B%\!<%k$,%9%?%C%/$7$F$$$k$H$-(B */
  if (game_time - last_kick <= 10) chk_stack++;
  else chk_stack = 0;
  if (chk_stack >= 50) kick_pow = 100.0;
  if (chk_stack >= 100) kick_dir = random() % 360 - 180;
  last_kick = game_time;

  send_com_kick(&sock, kick_pow, kick_dir);

  if (uncertain == 0) {
    ball_vel_x	+= kick_pow * KICK_RATE * cos(Deg2Rad(kick_dir + my_dir));
    ball_vel_y	+= kick_pow * KICK_RATE * sin(Deg2Rad(kick_dir + my_dir));
    ball_vel	= sqrt(Pow(ball_vel_x) + Pow(ball_vel_y));
  }
}

/*
 * $BA0?J$9$k(B($B4pAC(B)
 */

void dash(double dash_pow)
{
  /* dashtest */
  /*dash_pow = 100;*/
  if (game_mode & 1)
    dash_pow = restrict(dash_pow, 0, my_stamina - STAMINA_THR);

  /*dash_pow = restrict(dash_pow, POWER_MIN, POWER_MAX);*/
  if (chase_flag)
    dash_pow = restrict(dash_pow, 0, POWER_MAX);
  else
    dash_pow = restrict(dash_pow, 0, POWER_MAX * WALK_RATE);
  send_com_dash(&sock, dash_pow);

  if (dash_pow > my_stamina)
    dash_pow = my_stamina;
  my_stamina -= dash_pow * my_effort;

  my_vel_x	+= dash_pow * DASH_RATE * cos(Deg2Rad(my_dir));
  my_vel_y	+= dash_pow * DASH_RATE * sin(Deg2Rad(my_dir));
  my_vel	= sqrt(Pow(my_vel_x) + Pow(my_vel_y));
}

/*
 * $B8~$-$rJQ$($k(B($B4pAC(B)
 */

void turn(double turn_dir)
{
  double tmp1, tmp2;
  int i;

  turn_dir = regDeg(turn_dir);

#if 1
  if (Abs(turn_dir) >= my_view * VIEW_ROUGH)
    info_flag &= ~1;
#endif

#if 1
  tmp1 = turn_dir * (1.0 + 5.0 * my_vel);
  tmp2 = restrict(tmp1, -180, 180);
  if (tmp1 != 0) turn_dir *= tmp2 / tmp1;
  send_com_turn(&sock, tmp2);
#else
  send_com_turn(&sock, turn_dir);
#endif

  my_dir += turn_dir;
  my_dir = regDeg(my_dir);
  ball_dir -= turn_dir;
  ball_dir = regDeg(ball_dir);
  for (i=0; i<seen_num; i++) {
    seen_player[i].dir -= turn_dir;
    seen_player[i].dir = regDeg(seen_player[i].dir);
  }
}

/*
 * $B=V4V0\F0(B($B4pAC(B)
 */

void move(double x, double y)
{
  int i, j;

  send_com_move(&sock, x, y);

  my_x		= x;
  my_y		= y;
  my_Sx		= L2Sx(my_x);
  my_Sy		= L2Sy(my_y);
  my_gox	= x;
  my_goy	= y;

  my_vel_x	= 0.0;
  my_vel_y	= 0.0;
  my_vel	= 0.0;

  ball_time	= game_time;
  ball_x	= 0.0;
  ball_y	= 0.0;
  ball_ex	= 0.0;
  ball_ey	= 0.0;
  ball_Sx	= 0;
  ball_Sy	= 0;

  ball_vel_time	= game_time;
  ball_vel_x	= 0.0;
  ball_vel_y	= 0.0;
  ball_vel	= 0.0;

  for (j=0; j<SMALL_Y; j++)
    for (i=0; i<SMALL_X; i++)
      map_char[i][j] = 0;

  info_flag	= 2;
  turn_flag	= 1;
  seebl_flag	= 0;
  reached_posi	= 0;
  reached_ball	= 0;
  last_say	= -999;
  last_sense	= -999;
  last_reward	= -999;
  last_posi	= -999;
  chase_flag	= 0;

  seen_num	= 0;
  seen_enemy	= 0;

  posi_init();
}

/*
 * $B%l%U%j!<$+$i$N>pJs$rJ9$-<h$k(B
 */

void get_mode(char* message)
{
  char		kick_side;
  FILE		*fp;
  char		fname[20];
  int		goal;

  if (strncmp("play_on", message, 7) == 0)
    game_mode = 0;
  else if (sscanf(message, "kick_off_%c", &kick_side) == 1 ||
	   sscanf(message, "kick_in_%c", &kick_side) == 1 ||
	   sscanf(message, "free_kick_%c", &kick_side) == 1 ||
	   sscanf(message, "corner_kick_%c", &kick_side) == 1 ||
	   sscanf(message, "goal_kick_%c", &kick_side) == 1) {
    if ((kick_side == 'l' && game_side == S_LEFT) ||
	(kick_side == 'r' && game_side == S_RIGHT))
      game_mode = 1;
    else
      game_mode = 2;
    last_reward = game_time;
    if (sscanf(message, "kick_off_%c", &kick_side) == 1)
      game_mode |= 16;
  } else if (sscanf(message, "offside_%c", &kick_side) == 1) {
    if ((kick_side == 'l' && game_side == S_LEFT) ||
	(kick_side == 'r' && game_side == S_RIGHT)) {
      game_mode = 6;
      last_reward = game_time;
#if 0
      /* check 1.1 */
      if (learn_flag & 1)
	if (my_x > ball_x &&
	    ball_dist < OFFSIDE_AREA+1.0) reward(-1.0);
#endif
    } else {
      game_mode = 5;
#if 0
      /* check 1.2 */
      if (learn_flag & 1) reward(0.2);
#endif
    }
  } else if (strncmp("goal_", message, 5) == 0 ||
	     strncmp("before_kick_off", message, 15) == 0) {
    /* $B3X=,ESCf7k2L$r%U%!%$%k$K=PNO$9$k(B */
    if (learn_flag & 1) {
      sprintf(fname, "%s%02d.pos", game_team, my_unum);
      if ((fp = fopen(fname, "w")) == NULL) {
	fprintf(stderr, "%s: can't write.\n", fname);
	exit(1);
      }
      posi_output(fp);
      fflush(fp);
      fclose(fp);
/*      usleep(WAIT_TIME); */
    }
    if (sscanf(message, "goal_%c", &kick_side) == 1) {
      if ((kick_side == 'l' && game_side == S_LEFT) ||
          (kick_side == 'r' && game_side == S_RIGHT)) {
	game_my_score ++;
	goal = 1;
#if 1
	/* Change Mode */
	if ((learn_flag & 5) == 5)
	  learn_flag &= ~2;
#endif
      } else {
	game_op_score ++;
	goal = -1;

#if 1
	/* Change Position Mode */
	if (learn_flag & 2) {
	  posi_mode ++;
	  if (posi_mode > 1) {
	    posi_mode = 0;
	    learn_flag &= ~2;
	    /*posi_mode = 1;*/
	  }
	}
	/* Change Mode */
	else if ((learn_flag & 5) == 5)
	  learn_flag |= 2;
#endif
      }

#if 0
      /* check 4 */
      /* $BF@E@$K$h$kJs=7(B */
      if (learn_flag & 1) {
	if (goal > 0) reward(1.0);
	/* else reward(-1.0); */
      }
#endif
      /* $BF@E@$NI=<((B */
      if (output_flag & 1) {
	if (goal > 0)
	  printf("%s %2d %ld\tscore_my: %d %d\n",
		 game_team, my_unum, game_time, game_my_score, game_op_score);
	else
	  printf("%s %2d %ld\tscore_op: %d %d\n",
		 game_team, my_unum, game_time, game_my_score, game_op_score);
	fflush(stdout);
      }

#if 1
      /* $B%m!<%F!<%7%g%s(B(rotation(strict)) */
      my_unum -= 3;
      if (my_unum < 1) my_unum += 11;
#elif 1
      /* $B%m!<%F!<%7%g%s(B(rotation(strict)) */
      if (my_unum >= 2) my_unum += 10;
      if (my_unum > 11) my_unum -= 10;
#elif 1
      /* $B%m!<%F!<%7%g%s(B(rotation(normal)) */
      if (my_unum >= 2 && !(learn_flag & 1)) {
	my_unum += 3;
	if (my_unum > 11) my_unum -= 10;
	if ((learn_flag & 3) != 2) {
	  sprintf(fname, "%s%02d.pos", game_team, my_unum);
	  if ((fp = fopen(fname, "r")) == NULL) {
	    fprintf(stderr, "%s: initialized by zero.\n", fname);
	    /* exit(1); */
	    posi_rand_init(1);
	  } else {
	    posi_input(fp);
	    fclose(fp);
	  }
	}
      }
#endif
    }
    game_mode = 8;
    init_position();
    move(my_gox, my_goy);
  } else if (strncmp("goalie_catch_ball_", message, 18) == 0) {
    if ((kick_side == 'l' && game_side == S_LEFT) ||
	(kick_side == 'r' && game_side == S_RIGHT)) {
      if (my_unum == 1) printf("I catched the ball.\n", message);
    }
#if 0
  } else if (strncmp("half_time", message, 9) == 0 ||
	     strncmp("time_extended", message, 13) == 0) {
    if ((learn_flag & 5) == 5)
      learn_flag ^= 2;
#endif
  } else if (strncmp("time_over", message, 9) == 0) {
    game_mode = 8;
  } else { /* unspecified */
    printf("refree said: %s\n", message);
    /* game_mode = 0; */
  }
}

/*
 * $B%]%8%7%g%s$J$I$rEAC#$9$k(B
 */

void say(void)
{
  static char	buf[MAXMESG];
  static int	last_Sx, last_Sy;
  int		x, y, i;
  int		tmp_char;
  long		sum;

  /* $BEAC#$9$k;~$K$O<+J,$N0LCV$b4^$a$k(B */
  tmp_char = map_char[my_Sx][my_Sy];
  if (my_time >= map_time)
    map_char[my_Sx][my_Sy] |= 0xd;

  /* $BA02s<+J,$,$$$?>l=j$K$O<+J,$,$$$J$$(B */
  map_char[last_Sx][last_Sy] |= 8;

  sprintf(buf, "%-11s %04ld %02d ", game_team, game_time%10000, game_mode);
  sprintf(buf+20, "%04d ",
	  (int) (ball_dist - (my_stamina-STAMINA_THR) * PL_ONESTEP * DASH_RATE));
  sprintf(buf+25, "%04ld %04d %04d ",
	  ball_time%10000, (int)(ball_x * 10), (int)(ball_y * 10));
  sprintf(buf+40, "%04ld %04d %04d ",
	  ball_vel_time%10000, (int)(ball_vel_x * 100), (int)(ball_vel_y * 100));
  sprintf(buf+55, "%04ld ", map_time%10000);
  for (y=0; y<SMALL_Y; y++)
    for (x=0; x<SMALL_X; x++)
      sprintf(buf+60+y*SMALL_X+x, "%x", map_char[x][y]);

  /* $B%A%'%C%/%5%`(B */
  sum = 0;
  for (i=0; i<236; i++)
    sum += buf[i] * ((i%10)+1);
  sum = sum % 10000;
  sprintf(buf+60+SMALL_X*SMALL_Y, " %04ld\0", sum);

  map_char[my_Sx][my_Sy] = tmp_char;

  last_Sx = my_Sx;
  last_Sy = my_Sy;
  last_say = game_time;
  send_com_say(&sock, buf);
}

/*
 * $B%]%8%7%g%s$J$I$rJ9$-<h$k(B
 */

void hear(HearInfo info)
{
  static char	name[16];
  int		x, y, i;
  long		t;
  char		c;
  int		tmp_char;
  long		sum, tmp;

  game_time = info.time;

  if (info.sender == ST_Self) return;

  if (info.sender == ST_Referee) {
    get_mode(info.message);
    return;
  }

  /* return; */

  /* $BL#J}$N%a%C%;!<%8(B */
  if (strlen(info.message) != 241) return;
  if (sscanf(info.message, "%s ", name) == 0) return;
  if (strcmp(name, game_team) != 0) return;

  /* $B%A%'%C%/%5%`(B */
  sum = 0;
  for (i=0; i<236; i++)
    sum += info.message[i] * ((i%10)+1);
  sum = sum % 10000;
  sscanf(info.message+236, " %d", &tmp);
  if (sum != tmp) return;

  /* game_time and game_mode are unused */

  sscanf(info.message+20, "%d ", &x);
  if (ball_mate_time < info.time - BALL_MATE_FREQ || ball_mate >= x) {
    ball_mate		= x;
    ball_mate_time	= info.time;
    /* printf("ball_mate: %g\n", ball_mate); */
  }

  /* $B%\!<%k$N>pJs(B */
  sscanf(info.message+25, "%ld ", &t);
  if (t > 9000 && (game_time % 10000) < 1000)
    t += (game_time / 10000) * 10000 - 10000;
  else
    t += (game_time / 10000) * 10000;
  if (t > ball_time + 2*seebl_flag) {
    sscanf(info.message+30, "%d %d ", &x, &y);
    info_flag	|= 2;
    seebl_flag	= 0;
    ball_x	= x * 0.1;
    ball_y	= y * 0.1;
    ball_dir	= Rad2Deg(atan2(ball_y - my_y, ball_x - my_x)) - my_dir;
    ball_dir	= regDeg(ball_dir);
    ball_dist	= sqrt(Pow(ball_x - my_x) + Pow(ball_y - my_y));
    ball_time	= t;
  }

  /* $B%\!<%k$NB.EY$N>pJs(B */
  sscanf(info.message+40, "%ld ", &t);
  if (t > 9000 && (game_time % 10000) < 1000)
    t += (game_time / 10000) * 10000 - 10000;
  else
    t += (game_time / 10000) * 10000;
  if (t > ball_vel_time + 2*seebl_flag) {
    sscanf(info.message+45, "%d %d ", &x, &y);
    ball_vel_x		= x * 0.01;
    ball_vel_y		= y * 0.01;
    ball_vel		= sqrt(Pow(ball_vel_x) + Pow(ball_vel_y));
    ball_vel_time	= t;
  }

  /* $B%]%8%7%g%s$N>pJs(B */
  sscanf(info.message+55, "%ld ", &t);
  if (t > 9000 && (game_time % 10000) < 1000)
    t += (game_time / 10000) * 10000 - 10000;
  else
    t += (game_time / 10000) * 10000;
  if (t >= map_time - 1) {
    tmp_char = map_char[my_Sx][my_Sy];
    for (y=0; y<SMALL_Y; y++)
      for (x=0; x<SMALL_X; x++) {
	sscanf(info.message+60+y*SMALL_X+x, "%c", &c);
	c = (c>='0'&&c<='9') ? (c-'0') : (10+c-'a');
	if (c & 8) {
	  c &= ~8;
	  if ((c & 4) && (map_char[x][y] & 4))
	    map_char[x][y] |= c;
	  else if ((map_char[x][y] & 8) == 0)
	    map_char[x][y] = c;
	}
      }
    map_char[my_Sx][my_Sy] = tmp_char;
    /*map_time = t;*/
  }
}

/*
 * $B;k3P>pJs$rFI$_$H$k(B
 */

void see(SeeInfo info)
{
  PosState	pstate;
  double	tmp_dir, tmp_x, tmp_y;
  int		x, y, i;
  int		out_of_field;

  info_flag |= 1;
  see_flag = 0;
  game_time = info.time;

  /* $B8=:_0LCV$r5a$a$k(B */
  if (estimate_current_pos(&info, game_side, &pstate)) {
    info_flag |= 4;
    my_x = pstate.pos.x;
    my_y = pstate.pos.y;
    my_Sx = L2Sx(my_x);
    my_Sy = L2Sy(my_y);
    my_dir = pstate.dir;
    my_time = info.time;
  } else { /* $B3QEY$@$1$G$b5a$a$k(B */
    out_of_field = 0;
    for (i=0; i<info.n_obj; i++) {
      if (info.obj[i].type == OT_Line) {
	if (i != info.n_obj - 1 && info.obj[i+1].type == OT_Line)
	  out_of_field = 1;
	switch(info.obj[i].id.lpos) {
	 case LP_T:
	  if (out_of_field)
	    my_dir = - info.obj[i].dir - ((info.obj[i].dir > 0) ? -180 : 0);
	  else
	    my_dir = - info.obj[i].dir - ((info.obj[i].dir < 0) ? 180 : 0);
	  break;
	 case LP_B:
	  if (out_of_field)
	    my_dir = - info.obj[i].dir - ((info.obj[i].dir < 0) ? 180 : 0);
	  else
	    my_dir = - info.obj[i].dir - ((info.obj[i].dir > 0) ? -180 : 0);
	  break;
	 case LP_L:
	  if (out_of_field)
	    my_dir = - info.obj[i].dir - ((info.obj[i].dir > 0) ? -90 : 90);
	  else
	    my_dir = - info.obj[i].dir - ((info.obj[i].dir < 0) ? -90 : 90);
	  break;
	 case LP_R:
	  if (out_of_field)
	    my_dir = - info.obj[i].dir - ((info.obj[i].dir < 0) ? -90 : 90);
	  else
	    my_dir = - info.obj[i].dir - ((info.obj[i].dir > 0) ? -90 : 90);
	  break;
	 case LP_Unknown:
	  break;
	}
	if (game_side == S_RIGHT)
	  my_dir += ((my_dir > 0) ? -180 : 180);
	break;
      }
    }
    if (i == info.n_obj) info_flag &= ~4;
  }

  /* $B%9%b!<%k%F!<%V%k$OL$99?7>uBV(B */
  if (info.time > map_time)
    for (y=0; y<SMALL_Y; y++)
      for (x=0; x<SMALL_X; x++)
	map_char[x][y] &= ~8;

  /* $B<+J,$NB.EY$r5a$a$k(B */
  for (i=0; i<info.n_obj; i++) {
    if ((info.obj[i].type == OT_Flag || info.obj[i].type == OT_Goal) &&
	Abs(info.obj[i].dir_chng) <= 180 &&
	Abs(info.obj[i].dist_chng) < 8.0) {
      tmp_x = info.obj[i].dist_chng * cos(Deg2Rad(info.obj[i].dir))
	+ Deg2Rad(info.obj[i].dir_chng) *
	  info.obj[i].dist * sin(Deg2Rad(info.obj[i].dir));
      tmp_y = info.obj[i].dist_chng * sin(Deg2Rad(info.obj[i].dir))
	+ Deg2Rad(info.obj[i].dir_chng) *
	  info.obj[i].dist * cos(Deg2Rad(info.obj[i].dir));
      my_vel_x	= - tmp_x*cos(Deg2Rad(my_dir)) + tmp_y*sin(Deg2Rad(my_dir));
      my_vel_y	= - tmp_y*cos(Deg2Rad(my_dir)) - tmp_x*sin(Deg2Rad(my_dir));
      my_vel	= sqrt(Pow(my_vel_x) + Pow(my_vel_y));
      my_vel_time	= info.time;
      break;
    }
  }

  seen_num = 0;
  seen_enemy = 0;
  for (i=0; i<info.n_obj; i++) {

    /* $B%W%l%$%d!<$N>pJs$r%9%b!<%k%F!<%V%k$KG[CV(B */
    if (info.obj[i].type == OT_Player) {
      tmp_x = my_x+info.obj[i].dist*cos(Deg2Rad(info.obj[i].dir+my_dir));
      tmp_y = my_y+info.obj[i].dist*sin(Deg2Rad(info.obj[i].dir+my_dir));
      x = L2Sx(tmp_x);
      y = L2Sy(tmp_y);
      map_char[x][y] |= 0xc;
      if (info.obj[i].id.player.team == WT_Our)
	map_char[x][y] |= 1;
      else if (info.obj[i].id.player.team == WT_Opponent)
	map_char[x][y] |= 2;
      /*if (info.obj[i].dist < 20 && info.obj[i].id.player.team != WT_Our) {*/
      /*if (info.obj[i].id.player.team != WT_Our) {*/
      if (seen_num == 0)
	nearest_player = info.obj[i];
      else if (info.obj[i].dist < nearest_player.dist)
	nearest_player = info.obj[i];
      seen_player[seen_num] = info.obj[i];
      seen_num ++;
      if (info.obj[i].id.player.team != WT_Our) {
	if (seen_enemy == 0)
	  nearest_enemy = info.obj[i];
	else if (info.obj[i].dist < nearest_enemy.dist)
	  nearest_enemy = info.obj[i];
	seen_enemy ++;
      }
    }

    if (info.obj[i].type == OT_Ball && !(game_mode & 8)) {
      ball_dir	= info.obj[i].dir;
      ball_dist	= info.obj[i].dist;
      ball_dir_chng = 0.0;
      ball_dist_chng = 0.0;

      /* $B%\!<%k$N0LCV$rGD0.(B */
      info_flag |= 2;
      seebl_flag= 1;
      ball_x	= my_x + ball_dist * cos(Deg2Rad(ball_dir+my_dir));
      ball_y	= my_y + ball_dist * sin(Deg2Rad(ball_dir+my_dir));
      ball_time	= info.time;

      /* $B%\!<%k$NB.EY(B */
      if (Abs(info.obj[i].dir_chng) <= 180 &&
	  Abs(info.obj[i].dist_chng) < 6.0) {
	ball_dir_chng = info.obj[i].dir_chng;
	ball_dist_chng = info.obj[i].dist_chng;

	tmp_x	= info.obj[i].dist_chng * cos(Deg2Rad(ball_dir))
	  + Deg2Rad(info.obj[i].dir_chng)* ball_dist* sin(Deg2Rad(ball_dir));
	tmp_y	= info.obj[i].dist_chng * sin(Deg2Rad(ball_dir))
	  + Deg2Rad(info.obj[i].dir_chng)* ball_dist* cos(Deg2Rad(ball_dir));
	ball_vel_x = tmp_x*cos(Deg2Rad(my_dir)) - tmp_y*sin(Deg2Rad(my_dir))
	  + my_vel_x;
	ball_vel_y = tmp_y*cos(Deg2Rad(my_dir)) + tmp_x*sin(Deg2Rad(my_dir))
	  + my_vel_y;
	ball_vel	= sqrt(Pow(ball_vel_x) + Pow(ball_vel_y));
	ball_vel_time	= info.time;
      } else {
	ball_vel_x	= 0.0;
	ball_vel_y	= 0.0;
	ball_vel	= 0.0;
      }
    }
  }
#if 1
  /* $B%\!<%k$,8+$($k$O$:$J$N$K8+$($J$$;~(B */
  if (ball_time != info.time
      && (info_flag & 2) == 2
      && Abs(ball_dir) <= my_view * VIEW_ROUGH * 0.5) {
    info_flag &= ~2;
    seebl_flag = 0;
    turn_flag = (ball_dir >= 0)? 1: -1;
  }
#endif

  /* $B%9%b!<%k%F!<%V%k$K6uGr$rKd$a$k(B */
  tmp_x = my_x + cos(Deg2Rad(my_dir)) * 3.0 / sin(Deg2Rad(my_view/2.0));
  tmp_y = my_y + sin(Deg2Rad(my_dir)) * 3.0 / sin(Deg2Rad(my_view/2.0));
  for (y=0; y<SMALL_Y; y++)
    for (x=0; x<SMALL_X; x++) {
      tmp_dir = Rad2Deg(atan2(S2Ly(y) - tmp_y, S2Lx(x) - tmp_x)) - my_dir;
      tmp_dir = regDeg(tmp_dir);
      if ((Abs(tmp_dir) < my_view/2.0
	   || (abs(x-my_Sx) + abs(y-my_Sy) <= 1))
	  && (map_char[x][y] & 8) == 0)
	map_char[x][y] = 8;
    }

  map_time = info.time;
}

/*
 * $BJs=7$rM?$($k(B
 */

void reward(double rew)
{
  if (rew >= 0)	posi_reward(rew, 0);
  else		posi_reward(-rew, 1);
  if (output_flag & 0x2) {
    printf("%s %2d %ld\treward: %g\n",
	   game_team, my_unum, game_time, rew);
    fflush(stdout);
  }
  if (output_flag & 0x10) {
    posi_output(stdout);
    fflush(stdout);
  }
}

/*
 * $BFbIt>uBV$rI=<($9$k(B($B%F%9%HMQ(B)
 */

void show(void)
{
  int x, y;

  printf("game\t: %06ld %s side %d unum %d mode %d\n",
	 game_time, game_team, game_side, my_unum, game_mode);
  printf("my\t: %06ld px %g py %g dr %g st %g ef %g vw %g un %d\n",
	 my_time, my_x, my_y, my_dir, my_stamina, my_effort, my_view, my_unum);
  printf("my_v\t: %06ld vx %g vy %g\n",
	 my_vel_time, my_vel_x, my_vel_y);
  printf("ball\t: %06ld px %g py %g dr %g ds %g\n",
	 ball_time, ball_x, ball_y, ball_dir, ball_dist);
  printf("ball_v\t: %06ld vx %g vy %g\n",
	 ball_vel_time, ball_vel_x, ball_vel_y);
  printf("ball_m\t: %06ld bm %g\n",
	 ball_mate_time, ball_mate);
  printf("misc\t: if %d sb %d sn %d se %d\n",
	 info_flag, seebl_flag, seen_num, seen_enemy);
  printf("offsideline\t: %d %d\n",
	 offsideline, offsideback);
  printf("my_S\t: %d %d\n", my_Sx, my_Sy);
  printf("my_go\t: %g %g\n", my_gox, my_goy);
  printf("reached_posi: %d reached_ball:%d\n", reached_posi, reached_ball);

  printf("pos\t: %06ld\n", map_time);
  for (y=0; y<SMALL_Y; y++) {
    for (x=0; x<SMALL_X; x++)
      printf("%x ", map_char[x][y]);
    printf("\n");
  }

  fflush(stdout);
}

/*
 * $BFbIt>uBV$r=i4|2=$9$k(B
 */

void initialize(void)
{
  int		x, y;

  my_time	= -999;
  my_x		= -999.0;
  my_y		= -999.0;
  my_Sx		= 0;
  my_Sy		= 0;
  my_dir	= 0.0;
  my_stamina	= STAMINA_MAX;
  my_effort	= EFFORT_MAX;
#if 1
  send_com_change_view(&sock, VW_Normal, VQ_high);
  my_view	= 90.0;
#elif 0
  send_com_change_view(&sock, VW_Narrow, VQ_high);
  my_view	= 45.0;
#else
  send_com_change_view(&sock, VW_Wide, VQ_high);
  my_view	= 180.0;
#endif
  usleep(WAIT_TIME);

  my_vel_time	= -999;
  my_vel_x	= 0.0;
  my_vel_y	= 0.0;
  my_vel	= 0.0;

  my_unum	= game_unum;

  ball_time	= -999;
  ball_x	= 0.0;
  ball_y	= 0.0;
  ball_dir	= 0.0;
  ball_dist	= 0.0;
  ball_ex	= 0.0;
  ball_ey	= 0.0;
  ball_Sx	= 0;
  ball_Sy	= 0;

  ball_vel_time	= -999;
  ball_vel_x	= 0.0;
  ball_vel_y	= 0.0;
  ball_vel	= 0.0;

  ball_mate_time= -999;
  ball_mate	= 9999.0;

  map_time	= -999;
  for (y=0; y<SMALL_Y; y++)
    for (x=0; x<SMALL_X; x++) {
      map_char[x][y] = 0;
      sc_base[x][y][0] = sqrt(Pow(x) +  Pow(y-(SMALL_Y-1)/2));
      sc_base[x][y][1] = sqrt(Pow(x-(SMALL_X-1)) + Pow(y-(SMALL_Y-1)/2));
    }
  offsideline = SMALL_X-1;
  offsideback = 0;

  info_flag	= 0;
  see_flag	= 0;
  turn_flag	= 1;
  seebl_flag	= 0;
  reached_posi	= 0;
  reached_ball	= 0;
  last_say	= -999;
  last_sense	= -999;
  last_reward	= -999;
  last_posi	= -999;
  posi_mode	= 1;
  chase_flag	= 0;

  seen_num	= 0;
  seen_enemy	= 0;

  posi_init();
}

/* End Of File */
